=encoding utf8

=head1 NAME

Mail::Box::Search::Grep - select messages within a mail box like grep does

=head1 INHERITANCE

 Mail::Box::Search::Grep
   is a Mail::Box::Search
   is a Mail::Reporter

=head1 SYNOPSIS

 use Mail::Box::Manager;
 my $mgr    = Mail::Box::Manager->new;
 my $folder = $mgr->open('Inbox');

 my $filter = Mail::Box::Search::Grep->new
    ( label => 'selected'
    , in => 'BODY', match => qr/abc?d*e/
    );

 my @msgs   = $filter->search($folder);

 my $filter = Mail::Box::Search::Grep->new
   ( field => 'To'
   , match => $my_email
   );

 if($filter->search($message)) {...}

=head1 DESCRIPTION

Try to find some text strings in the header and footer of messages.  Various
ways to limit the search to certain header fields, the whole header, only
the body, the whole message, but even binary multiparts, are provided for.

The name I<grep> is derived from the UNIX tool I<grep>, which means: "Get
Regular Expression and Print".  Although you can search using regular
expressions (the Perl way of them), you do not have to print those as
result.

Extends L<"DESCRIPTION" in Mail::Box::Search|Mail::Box::Search/"DESCRIPTION">.
 
=head1 METHODS

Extends L<"METHODS" in Mail::Box::Search|Mail::Box::Search/"METHODS">.
 
=head2 Constructors

Extends L<"Constructors" in Mail::Box::Search|Mail::Box::Search/"Constructors">.
 
=over 4

=item Mail::Box::Search::Grep-E<gt>B<new>(%options)

Create a UNIX-grep like search filter.

 -Option    --Defined in       --Default
  binaries    Mail::Box::Search  <false>
  decode      Mail::Box::Search  <true>
  delayed     Mail::Box::Search  <true>
  deleted     Mail::Box::Search  <false>
  deliver                        undef
  field                          undef
  in          Mail::Box::Search  <$field ? 'HEAD' : C<'BODY'>>
  label       Mail::Box::Search  undef
  limit       Mail::Box::Search  0
  log         Mail::Reporter     'WARNINGS'
  logical     Mail::Box::Search  'REPLACE'
  match                          <required>
  multiparts  Mail::Box::Search  <true>
  trace       Mail::Reporter     'WARNINGS'

=over 2

=item binaries => BOOLEAN

=item decode => BOOLEAN

=item delayed => BOOLEAN

=item deleted => BOOLEAN

=item deliver => undef|CODE|'DELETE'|LABEL|'PRINT'|REF-ARRAY

Store the details about where the match was found.  The search may take
much longer when this feature is enabled.

When an ARRAY is specified it will contain a list of references to hashes.
Each hash contains the information of one match.  A match in a header
line will result in a line with fields C<message>, C<part>, and C<field>, where
the field is a L<Mail::Message::Field|Mail::Message::Field> object.  When the match is in
the body the hash will contain a C<message>, C<part>, C<linenr>, and C<line>.

In case of a CODE reference, that routine is called for each match. The
first argument is this search object and the second a reference to same
hash as would be stored in the array.

The C<PRINT> will call L<printMatchedHead()|Mail::Box::Search::Grep/"The Results"> or L<printMatchedBody()|Mail::Box::Search::Grep/"The Results"> when
any matching header resp body line was found.  The output is minimized
by not reprinting the message info on multiple matches in the same
message.

C<DELETE> will flag
the message to be deleted in case of a match.  When a multipart's part
is matched, the whole message will be flagged for deletion.

=item field => undef|STRING|REGEX|CODE

Not valid in combination with C<in> set to C<BODY>.
The STRING is one full field name (case-insensitive).  Use a REGEX
to select more than one header line to be scanned. CODE is a routine which
is called for each field in the header.   The CODE is called with the header
as first, and the field as second argument.  If the CODE returns true, the
message is selected.

=item in => 'HEAD'|'BODY'|'MESSAGE'

=item label => STRING

=item limit => NUMBER

=item log => LEVEL

=item logical => 'REPLACE'|'AND'|'OR'|'NOT'|'AND NOT'|'OR NOT'

=item match => STRING|REGEX|CODE

The pattern to be search for can be a REGular EXpression, or a STRING.  In
both cases, the match succeeds if it is found anywhere within the selected
fields.

With a CODE reference, that function will be called each field or body-line.
When the result is true, the details are delivered.  The call formats are

 $code->($head, $field);          # for HEAD searches
 $code->($body, $linenr, $line);  # for BODY searches

The C<$head> resp C<$body> are one message's head resp. body object.  The
C<$field> is a header line which matches.  The C<$line> and C<$linenr>
tell the matching line in the body.

Be warned that when you search in C<MESSAGE> the code must accept
both formats.

=item multiparts => BOOLEAN

=item trace => LEVEL

=back

=back

=head2 Searching

Extends L<"Searching" in Mail::Box::Search|Mail::Box::Search/"Searching">.
 
=over 4

=item $obj-E<gt>B<inBody>($part, $body)

Inherited, see L<Mail::Box::Search/"Searching">

=item $obj-E<gt>B<inHead>($part, $head)

Inherited, see L<Mail::Box::Search/"Searching">

=item $obj-E<gt>B<search>($folder|$thread|$message|ARRAY)

Inherited, see L<Mail::Box::Search/"Searching">

=item $obj-E<gt>B<searchPart>($part)

Inherited, see L<Mail::Box::Search/"Searching">

=back

=head2 The Results

Extends L<"The Results" in Mail::Box::Search|Mail::Box::Search/"The Results">.
 
=over 4

=item $obj-E<gt>B<printMatch>( [$fh], $match )

=item $obj-E<gt>B<printMatchedBody>($fh, $match)

=item $obj-E<gt>B<printMatchedHead>($fh, $match)

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Box::Search|Mail::Box::Search/"Error handling">.
 
=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<addReport>($object)

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<defaultTrace>( [$level]|[$loglevel, $tracelevel]|[$level, $callback] )

=item Mail::Box::Search::Grep-E<gt>B<defaultTrace>( [$level]|[$loglevel, $tracelevel]|[$level, $callback] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<errors>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<log>( [$level, [$strings]] )

=item Mail::Box::Search::Grep-E<gt>B<log>( [$level, [$strings]] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<logPriority>($level)

=item Mail::Box::Search::Grep-E<gt>B<logPriority>($level)

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<logSettings>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<report>( [$level] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<reportAll>( [$level] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<trace>( [$level] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<warnings>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Box::Search|Mail::Box::Search/"Cleanup">.
 
=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DIAGNOSTICS

=over 4

=item Error: Package $package does not implement $method.

Fatal error: the specific package (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.

=back

=head1 SEE ALSO

This module is part of Mail-Box distribution version 3.008,
built on October 04, 2019. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

Copyrights 2001-2019 by [Mark Overmeer]. For other contributors see ChangeLog.

This program is free software; you can redistribute it and/or modify it
under the same terms as Perl itself.
See F<http://dev.perl.org/licenses/>

